//
//  Coding.m
//  OME_BrowserXCoS
//
//  Created by Satoshi Takahashi on Sat Jul 27 2002.
//  Copyright (c) 2002 __MyCompanyName__. All rights reserved.
//

#include <stdio.h>
#include <string.h>

#import "Coding.h"
#import "Utils.h"

@implementation Coding

enum MyCode
{ASCII=1, ISO2022JP, ISOLatin1, ISOLatin2, JapaneseEUC, MacOSRoman, ShiftJIS,
UTF8, Unicode, MacKorean, MacChineseTrad, MacChineseSimp,
EUC_KR, Big5, GB_2312, ISOLatin3, ISOLatin4, ISOLatinCyrillic,
ISOLatinArabic, ISOLatinGreek, ISOLatinHebrew, ISOLatin5,
ISOLatin6, ISOLatinThai, ISOLatin7, ISOLatin8, ISOLatin9,
UnicodeEnglish, UnicodeJapanese, UnicodeKorean, UnicodeChineseTrad, 
UnicodeChineseSimp, UnicodeWestern, UnicodeCentralEuropean, 
UnicodeSouthEuropean, UnicodeBaltic, UnicodeCyrillic, 
UnicodeArabic, UnicodeGreek, UnicodeHebrew, UnicodeTurkish, 
UnicodeNordic, UnicodeThai, UnicodeCeltic, UTF8English, UTF8Japanese, 
UTF8Korean, UTF8ChineseTrad, 
UTF8ChineseSimp, UTF8Western, UTF8CentralEuropean, 
UTF8SouthEuropean, UTF8Baltic, UTF8Cyrillic, 
UTF8Arabic, UTF8Greek, UTF8Hebrew, UTF8Turkish, 
UTF8Nordic, UTF8Thai, UTF8Celtic};

enum LanguageName
{Unknown = 1, English, Japanese, Korean, ChineseTraditional, 
ChineseSimplified, Western, CentralEuropean, SouthEuropean, 
Baltic, Cyrillic, Arabic, Greek, Hebrew, Turkish, Nordic, Thai, 
Celtic};

- init
{
    self = [super init];
	[[NSNotificationCenter defaultCenter] addObserver: self
		selector: @selector(terminate:)
		name: NSApplicationWillTerminateNotification object:nil];    
    
    codeNameDict = [self initEncodeNameDict];
    fileCodeDict = [self initFileCodeDict];
    langNameDict = [self initLangNameDict];
    prefNameDict = [self initPrefNameDict];
    codeArray = [prefNameDict allKeys];
    [self initFontDict];
    codeArray = [codeArray sortedArrayUsingFunction: compareCode
                            context: prefNameDict];
    [codeArray retain];
    [fontTable reloadData];

    charsetCodeDict = [[NSMutableDictionary alloc] initWithCapacity: 1];
    omeCharsetCodeDict = [[NSMutableDictionary alloc] initWithCapacity: 1];
    [self initFileCoding];
//NSLog([codeNameDict description]);
//NSLog([charsetCodeDict description]);
    return self;
}


- (NSDictionary *)initEncodeNameDict
{
    return [[NSDictionary alloc] initWithObjectsAndKeys:
        NSEncode(ASCII), @"ASCII",
        NSEncode(ISO2022JP), @"ISO2022JP",
        NSEncode(ISOLatin1), @"ISOLatin1",
                    //ISO-8859-1
        NSEncode(ISOLatin2), @"ISOLatin2",
                    //Central European, ISO-8859-2
        NSEncode(JapaneseEUC), @"JapaneseEUC",
        NSEncode(JapaneseEUC), @"EUC_JP",
        NSEncode(MacOSRoman), @"MacOSRoman",
        //NSEncode(NEXTSTEP), @"NEXTSTEP",
        //NSEncode(NonLossyASCII), @"NonLossyASCII",
        NSEncode(ShiftJIS), @"ShiftJIS",
        //NSEncode(Symbol), @"Symbol",
        NSEncode(UTF8), @"UTF8",
        NSEncode(Unicode), @"Unicode",
        //NSEncode(WindowsCP1250), @"WindowsCP1250",
        //NSEncode(WindowsCP1251), @"WindowsCP1251",
        //NSEncode(WindowsCP1252), @"WindowsCP1252",
        //NSEncode(WindowsCP1253), @"WindowsCP1253",
        //NSEncode(WindowsCP1254), @"WindowsCP1254",
        NSEncode(MacKorean), @"MacKorean",
        NSEncode(MacChineseTrad), @"MacChineseTrad",
        NSEncode(MacChineseSimp), @"MacChineseSimp",
        NSEncode(EUC_KR), @"EUC_KR",
        NSEncode(Big5), @"Big5", //Traditional Chinese
        NSEncode(GB_2312), @"GB_2312", //Simplified Chinese
        NSEncode(ISOLatin3), @"ISOLatin3",
                        //Southeast European ISO-8859-3
        NSEncode(ISOLatin4), @"ISOLatin4", //Baltic ISO-8859-4
        NSEncode(ISOLatinCyrillic), @"ISOLatinCyrillic", //ISO-8859-5
        NSEncode(ISOLatinArabic), @"ISOLatinArabic", //ISO-8859-6
        NSEncode(ISOLatinGreek), @"ISOLatinGreek", //ISO-8859-7
        NSEncode(ISOLatinHebrew), @"ISOLatinHebrew", //ISO-8859-8
        NSEncode(ISOLatin5), @"ISOLatin5", //Turkish, ISO-8859-9
        NSEncode(ISOLatin6), @"ISOLatin6", //Nordic, ISO-8859-10
        NSEncode(ISOLatinThai), @"ISOLatinThai", //ISO-8859-11
        NSEncode(ISOLatin7), @"ISOLatin7", //Baltic, ISO-8859-13
        NSEncode(ISOLatin8), @"ISOLatin8", //Celtic, ISO-8859-14
        NSEncode(ISOLatin9), @"ISOLatin9", //Latin1+Euro, ISO-8859-15
        NSEncode(UnicodeEnglish), @"UnicodeEnglish",
        NSEncode(UnicodeJapanese), @"UnicodeJapanese",
        NSEncode(UnicodeKorean), @"UnicodeKorean",
        NSEncode(UnicodeChineseTrad), @"UnicodeChineseTrad",
        NSEncode(UnicodeChineseSimp), @"UnicodeChineseSimp",
        NSEncode(UnicodeWestern), @"UnicodeWestern",
        NSEncode(UnicodeCentralEuropean), @"UnicodeCentralEuropean",
        NSEncode(UnicodeSouthEuropean), @"UnicodeSouthEuropean",
        NSEncode(UnicodeBaltic), @"UnicodeBaltic",
        NSEncode(UnicodeCyrillic), @"UnicodeCyrillic",
        NSEncode(UnicodeArabic), @"UnicodeArabic",
        NSEncode(UnicodeGreek), @"UnicodeGreek",
        NSEncode(UnicodeHebrew), @"UnicodeHebrew",
        NSEncode(UnicodeTurkish), @"UnicodeTurkish",
        NSEncode(UnicodeNordic), @"UnicodeNordic",
        NSEncode(UnicodeThai), @"UnicodeThai",
        NSEncode(UnicodeCeltic), @"UnicodeCeltic",
        NSEncode(UTF8English), @"UTF8English",
        NSEncode(UTF8Japanese), @"UTF8Japanese",
        NSEncode(UTF8Korean), @"UTF8Korean",
        NSEncode(UTF8ChineseTrad), @"UTF8ChineseTrad",
        NSEncode(UTF8ChineseSimp), @"UTF8ChineseSimp",
        NSEncode(UTF8Western), @"UTF8Western",
        NSEncode(UTF8CentralEuropean), @"UTF8CentralEuropean",
        NSEncode(UTF8SouthEuropean), @"UTF8SouthEuropean",
        NSEncode(UTF8Baltic), @"UTF8Baltic",
        NSEncode(UTF8Cyrillic), @"UTF8Cyrillic",
        NSEncode(UTF8Arabic), @"UTF8Arabic",
        NSEncode(UTF8Greek), @"UTF8Greek",
        NSEncode(UTF8Hebrew), @"UTF8Hebrew",
        NSEncode(UTF8Turkish), @"UTF8Turkish",
        NSEncode(UTF8Nordic), @"UTF8Nordic",
        NSEncode(UTF8Thai), @"UTF8Thai",
        NSEncode(UTF8Celtic), @"UTF8Celtic",
            0];
}

- (NSDictionary *)initFileCodeDict
{
    return [[NSDictionary alloc] initWithObjectsAndKeys:
        NSEncode(NSASCIIStringEncoding), NSEncode(ASCII),
        NSEncode(NSISO2022JPStringEncoding), NSEncode(ISO2022JP),
        NSEncode(NSISOLatin1StringEncoding), NSEncode(ISOLatin1),
                    //ISO-8859-1
        NSEncode(NSISOLatin2StringEncoding), NSEncode(ISOLatin2),
                    //Central European, ISO-8859-2
        NSEncode(NSJapaneseEUCStringEncoding), NSEncode(JapaneseEUC),
        NSEncode(NSMacOSRomanStringEncoding), NSEncode(MacOSRoman),
        //NSEncode(NSNEXTSTEPStringEncoding), NSEncode(NEXTSTEP),
        //NSEncode(NSNonLossyASCIIStringEncoding), NSEncode(NonLossyASCII),
        NSEncode(NSShiftJISStringEncoding), NSEncode(ShiftJIS),
        //NSEncode(NSSymbolStringEncoding), NSEncode(Symbol),
        NSEncode(NSUTF8StringEncoding), NSEncode(UTF8),
        NSEncode(NSUnicodeStringEncoding), NSEncode(Unicode),
        //NSEncode(NSWindowsCP1250StringEncoding), NSEncode(WindowsCP1250),
        //NSEncode(NSWindowsCP1251StringEncoding), NSEncode(WindowsCP1251),
        //NSEncode(NSWindowsCP1252StringEncoding), NSEncode(WindowsCP1252),
        //NSEncode(NSWindowsCP1253StringEncoding), NSEncode(WindowsCP1253),
        //NSEncode(NSWindowsCP1254StringEncoding), NSEncode(WindowsCP1254),
        CFEncode(kCFStringEncodingMacKorean), NSEncode(MacKorean),
        CFEncode(kCFStringEncodingMacChineseTrad), NSEncode(MacChineseTrad),
        CFEncode(kCFStringEncodingMacChineseSimp), NSEncode(MacChineseSimp),
        CFEncode(kCFStringEncodingEUC_KR), NSEncode(EUC_KR),
        CFEncode(kCFStringEncodingBig5), NSEncode(Big5), //Traditional Chinese
        CFEncode(kCFStringEncodingEUC_CN), NSEncode(GB_2312), //Simplified Chinese
        CFEncode(kCFStringEncodingISOLatin3), NSEncode(ISOLatin3),
                        //Southeast European ISO-8859-3
        CFEncode(kCFStringEncodingISOLatin4), NSEncode(ISOLatin4), //Baltic ISO-8859-4
        CFEncode(kCFStringEncodingISOLatinCyrillic), NSEncode(ISOLatinCyrillic), //ISO-8859-5
        CFEncode(kCFStringEncodingISOLatinArabic), NSEncode(ISOLatinArabic), //ISO-8859-6
        CFEncode(kCFStringEncodingISOLatinGreek), NSEncode(ISOLatinGreek), //ISO-8859-7
        CFEncode(kCFStringEncodingISOLatinHebrew), NSEncode(ISOLatinHebrew), //ISO-8859-8
        CFEncode(kCFStringEncodingISOLatin5), NSEncode(ISOLatin5), //Turkish, ISO-8859-9
        CFEncode(kCFStringEncodingISOLatin6), NSEncode(ISOLatin6), //Nordic, ISO-8859-10
        CFEncode(kCFStringEncodingISOLatinThai), NSEncode(ISOLatinThai), //ISO-8859-11
        CFEncode(kCFStringEncodingISOLatin7), NSEncode(ISOLatin7), //Baltic, ISO-8859-13
        CFEncode(kCFStringEncodingISOLatin8), NSEncode(ISOLatin8), //Celtic, ISO-8859-14
        CFEncode(kCFStringEncodingISOLatin9), NSEncode(ISOLatin9), //Latin1+Euro, ISO-8859-15
        NSEncode(NSUnicodeStringEncoding), NSEncode(UnicodeEnglish),
        NSEncode(NSUnicodeStringEncoding), NSEncode(UnicodeJapanese),
        NSEncode(NSUnicodeStringEncoding), NSEncode(UnicodeKorean),
        NSEncode(NSUnicodeStringEncoding), NSEncode(UnicodeChineseTrad),
        NSEncode(NSUnicodeStringEncoding), NSEncode(UnicodeChineseSimp),
        NSEncode(NSUnicodeStringEncoding), NSEncode(UnicodeWestern),
        NSEncode(NSUnicodeStringEncoding), NSEncode(UnicodeCentralEuropean),
        NSEncode(NSUnicodeStringEncoding), NSEncode(UnicodeSouthEuropean),
        NSEncode(NSUnicodeStringEncoding), NSEncode(UnicodeBaltic),
        NSEncode(NSUnicodeStringEncoding), NSEncode(UnicodeCyrillic),
        NSEncode(NSUnicodeStringEncoding), NSEncode(UnicodeArabic),
        NSEncode(NSUnicodeStringEncoding), NSEncode(UnicodeGreek),
        NSEncode(NSUnicodeStringEncoding), NSEncode(UnicodeHebrew),
        NSEncode(NSUnicodeStringEncoding), NSEncode(UnicodeTurkish),
        NSEncode(NSUnicodeStringEncoding), NSEncode(UnicodeNordic),
        NSEncode(NSUnicodeStringEncoding), NSEncode(UnicodeThai),
        NSEncode(NSUnicodeStringEncoding), NSEncode(UnicodeCeltic),
        NSEncode(NSUTF8StringEncoding), NSEncode(UTF8English),
        NSEncode(NSUTF8StringEncoding), NSEncode(UTF8Japanese),
        NSEncode(NSUTF8StringEncoding), NSEncode(UTF8Korean),
        NSEncode(NSUTF8StringEncoding), NSEncode(UTF8ChineseTrad),
        NSEncode(NSUTF8StringEncoding), NSEncode(UTF8ChineseSimp),
        NSEncode(NSUTF8StringEncoding), NSEncode(UTF8Western),
        NSEncode(NSUTF8StringEncoding), NSEncode(UTF8CentralEuropean),
        NSEncode(NSUTF8StringEncoding), NSEncode(UTF8SouthEuropean),
        NSEncode(NSUTF8StringEncoding), NSEncode(UTF8Baltic),
        NSEncode(NSUTF8StringEncoding), NSEncode(UTF8Cyrillic),
        NSEncode(NSUTF8StringEncoding), NSEncode(UTF8Arabic),
        NSEncode(NSUTF8StringEncoding), NSEncode(UTF8Greek),
        NSEncode(NSUTF8StringEncoding), NSEncode(UTF8Hebrew),
        NSEncode(NSUTF8StringEncoding), NSEncode(UTF8Turkish),
        NSEncode(NSUTF8StringEncoding), NSEncode(UTF8Nordic),
        NSEncode(NSUTF8StringEncoding), NSEncode(UTF8Thai),
        NSEncode(NSUTF8StringEncoding), NSEncode(UTF8Celtic),
            0];
}

- (NSDictionary *) initLangNameDict
{
    return [[NSDictionary alloc] initWithObjectsAndKeys:
        NSEncode(English), NSEncode(ASCII),
        NSEncode(Japanese), NSEncode(ISO2022JP),
        NSEncode(Western), NSEncode(ISOLatin1),
        NSEncode(CentralEuropean), NSEncode(ISOLatin2),
        NSEncode(Western), NSEncode(MacOSRoman),
        //NSEncode(NEXTSTEP), NEXTSTEP,
        //NSEncode(NonLossyASCII), NonLossyASCII,
        NSEncode(Japanese), NSEncode(ShiftJIS),
        NSEncode(Japanese), NSEncode(JapaneseEUC),
        //NSEncode(Symbol), NSEncode(Symbol),
        NSEncode(Unknown), NSEncode(UTF8),
        NSEncode(Unknown), NSEncode(Unicode),
        //NSEncode(WindowsCP1250), WindowsCP1250),
        //NSEncode(WindowsCP1251), WindowsCP1251",
        //NSEncode(WindowsCP1252), WindowsCP1252",
        //NSEncode(WindowsCP1253), WindowsCP1253",
        //NSEncode(WindowsCP1254), WindowsCP1254",
        NSEncode(Korean), NSEncode(MacKorean),
        NSEncode(ChineseTraditional), NSEncode(MacChineseTrad),
        //NSEncode(ChineseSimplified), NSEncode(kCFStringEncodingMacChineseSimp),
        NSEncode(ChineseSimplified), NSEncode(MacChineseSimp),
        //NSEncode(Korean), NSEncode(kCFStringEncodingEUC_KR),
        NSEncode(Korean), NSEncode(EUC_KR),
        //NSEncode(ChineseTraditional), NSEncode(kCFStringEncodingBig5),
        NSEncode(ChineseTraditional), NSEncode(Big5),
        NSEncode(ChineseSimplified), NSEncode(GB_2312), /*EUC_CN*/
        NSEncode(SouthEuropean), NSEncode(ISOLatin3),
        NSEncode(Baltic), NSEncode(ISOLatin4),
        NSEncode(Cyrillic), NSEncode(ISOLatinCyrillic),
        NSEncode(Arabic), NSEncode(ISOLatinArabic),
        NSEncode(Greek), NSEncode(ISOLatinGreek),
        NSEncode(Hebrew), NSEncode(ISOLatinHebrew),
        NSEncode(Turkish), NSEncode(ISOLatin5),
        NSEncode(Nordic), NSEncode(ISOLatin6),
        NSEncode(Thai), NSEncode(ISOLatinThai),
        NSEncode(Baltic), NSEncode(ISOLatin7),
        NSEncode(Celtic), NSEncode(ISOLatin8),
        NSEncode(Western), NSEncode(ISOLatin9),
        NSEncode(English), NSEncode(UnicodeEnglish),
        NSEncode(Japanese), NSEncode(UnicodeJapanese),
        NSEncode(Korean), NSEncode(UnicodeKorean),
        NSEncode(ChineseTraditional), NSEncode(UnicodeChineseTrad),
        NSEncode(ChineseSimplified), NSEncode(UnicodeChineseSimp),
        NSEncode(Western), NSEncode(UnicodeWestern),
        NSEncode(CentralEuropean), NSEncode(UnicodeCentralEuropean),
        NSEncode(SouthEuropean), NSEncode(UnicodeSouthEuropean),
        NSEncode(Baltic), NSEncode(UnicodeBaltic),
        NSEncode(Cyrillic), NSEncode(UnicodeCyrillic),
        NSEncode(Arabic), NSEncode(UnicodeArabic),
        NSEncode(Greek), NSEncode(UnicodeGreek),
        NSEncode(Hebrew), NSEncode(UnicodeHebrew),
        NSEncode(Turkish), NSEncode(UnicodeTurkish),
        NSEncode(Nordic), NSEncode(UnicodeNordic),
        NSEncode(Thai), NSEncode(UnicodeThai),
        NSEncode(Celtic), NSEncode(UnicodeCeltic),
        NSEncode(Japanese), NSEncode(UnicodeJapanese),
        NSEncode(English), NSEncode(UTF8English),
        NSEncode(Korean), NSEncode(UTF8Korean),
        NSEncode(ChineseTraditional), NSEncode(UTF8ChineseTrad),
        NSEncode(ChineseSimplified), NSEncode(UTF8ChineseSimp),
        NSEncode(Western), NSEncode(UTF8Western),
        NSEncode(CentralEuropean), NSEncode(UTF8CentralEuropean),
        NSEncode(SouthEuropean), NSEncode(UTF8SouthEuropean),
        NSEncode(Baltic), NSEncode(UTF8Baltic),
        NSEncode(Cyrillic), NSEncode(UTF8Cyrillic),
        NSEncode(Arabic), NSEncode(UTF8Arabic),
        NSEncode(Greek), NSEncode(UTF8Greek),
        NSEncode(Hebrew), NSEncode(UTF8Hebrew),
        NSEncode(Turkish), NSEncode(UTF8Turkish),
        NSEncode(Nordic), NSEncode(UTF8Nordic),
        NSEncode(Thai), NSEncode(UTF8Thai),
        NSEncode(Celtic), NSEncode(UTF8Celtic),
            0];
}


- (NSDictionary *) initPrefNameDict
{
    return [[NSDictionary alloc] initWithObjectsAndKeys:
        Localize(@"Unknown"), NSEncode(Unknown),
        Localize(@"English"), NSEncode(English),
        Localize(@"Japanese"), NSEncode(Japanese),
        Localize(@"Korean"), NSEncode(Korean),
        Localize(@"Chinese Traditional"), NSEncode(ChineseTraditional),
        Localize(@"Chinese Simplified"), NSEncode(ChineseSimplified),
        Localize(@"Western"), NSEncode(Western),
        Localize(@"Central European"), NSEncode(CentralEuropean),
        Localize(@"South European"), NSEncode(SouthEuropean),
        Localize(@"Baltic"), NSEncode(Baltic),
        Localize(@"Cyrillic"), NSEncode(Cyrillic),
        Localize(@"Arabic"), NSEncode(Arabic),
        Localize(@"Greek"), NSEncode(Greek),
        Localize(@"Hebrew"), NSEncode(Hebrew),
        Localize(@"Turkish"), NSEncode(Turkish),
        Localize(@"Nordic"), NSEncode(Nordic),
        Localize(@"Thai"), NSEncode(Thai),
        Localize(@"Celtic"), NSEncode(Celtic),
            0];
}


NSNumber *NSEncode(unsigned int nsEncode)
{
    return [NSNumber numberWithUnsignedInt: nsEncode];
}


NSNumber *CFEncode(CFStringEncoding cfEncode)
{
    return NSEncode(CFStringConvertEncodingToNSStringEncoding(cfEncode));
}


- (void) initFontDict
{
NSEnumerator *encodeEnum;
NSNumber *encodeNum;
NSFont *encodeFont;

    fontDict = [[NSMutableDictionary alloc] init];
    encodeEnum = [[prefNameDict allKeys] objectEnumerator];
    
    while (encodeNum = [encodeEnum nextObject])
    {
        [fontDict setObject: [NSFont systemFontOfSize: 14] forKey: encodeNum];
    }
    encodeFont = [NSFont fontWithName: @"Osaka-Mono" size: 14];
//NSLog([[[NSFontManager sharedFontManager] availableFonts] description]);
//NSLog(@"encodeFont");
//NSLog([encodeFont description]);
    if (encodeFont)
    {
        [fontDict setObject: encodeFont forKey: NSEncode(Japanese)];
    }
        
    
    [self loadEncodeFontDictionaryOfNumber:[[prefNameDict allKeys] count]];
    
}


- (void) loadEncodeFontDictionaryOfNumber: (int)maxNumber
{
NSArray *saveCodeArray;
NSArray *fontNames;
NSArray *fontSizes;
NSEnumerator *codeEnum;
NSEnumerator *nameEnum;
NSEnumerator *sizeEnum;
NSNumber *codeNum;
NSString *fontName;
NSNumber *fontSize;


    saveCodeArray = [[NSUserDefaults standardUserDefaults]
            arrayForKey: @"Code-Numbers"];
    if (!saveCodeArray || [saveCodeArray count] > maxNumber)
        return;
    fontNames = [[NSUserDefaults standardUserDefaults]
            arrayForKey: @"Font-Names"];
    fontSizes = [[NSUserDefaults standardUserDefaults]
            arrayForKey: @"Font-Sizes"];
    codeEnum = [saveCodeArray objectEnumerator];
    nameEnum = [fontNames objectEnumerator];
    sizeEnum = [fontSizes objectEnumerator];
    while (codeNum = [codeEnum nextObject])
    {
        fontName = [nameEnum nextObject];
        fontSize = [sizeEnum nextObject];
        [fontDict setObject: [NSFont fontWithName: fontName
                    size: [fontSize floatValue]] forKey: codeNum];
    }
    
    return;
}
    


- (void) initFileCoding
{
NSString *fileEncodeListPath = [[NSBundle mainBundle]
                pathForResource: @"FileEncodeList" ofType: @"txt"];
FILE *fp;
char line[1024];
char *currentString;
char command[64];
char string[64];
char value[64];
NSNumber *valueNumber;
char key[64];
char key2[66];
int readNum;

    
    fp = fopen([fileEncodeListPath fileSystemRepresentation], "r");
    while(fgets(line, 1024, fp))
    {
        if (line[0] == '#')
            continue;
        currentString = line;
        sscanf(currentString, "%s", command);
        currentString += strlen(command)+1;
        
        if (!strcmp(command, "default"))
        {
            sscanf(currentString, "%s", string);            
            [self setDefaultCode: [(NSNumber *)[codeNameDict objectForKey:
                    [NSString stringWithCString: string]] unsignedIntValue]];
            continue;
        }
        if (!strcmp(command, "multipart"))
        {
            sscanf(currentString, "%s", string);            
            [self setMultipartFileCoding: [(NSNumber *)[codeNameDict objectForKey:
                    [NSString stringWithCString: string]] unsignedIntValue]];
            continue;
        }
        if (!strcmp(command, "send"))
        {
            sscanf(currentString, "%s", string);            
            [self setSendFileCoding: [(NSNumber *)[codeNameDict objectForKey:
                    [NSString stringWithCString: string]] unsignedIntValue]];
            continue;
        }
        else if (!strcmp(command, "encode") || !strcmp(command, "omeCharCode") )
        {
		NSMutableDictionary *codeDict = 0;
			if (!strcmp(command, "encode"))
				codeDict = charsetCodeDict;
			else if (!strcmp(command, "omeCharCode"))
				codeDict = omeCharsetCodeDict;
            sscanf(currentString, "%s", value);
            currentString += strlen(value)+1;
            valueNumber = [codeNameDict objectForKey:
                            [NSString stringWithCString:value]];
            if (!valueNumber)
                continue;
            while (currentString[0] && currentString[0] != '\n')
            {
                readNum = sscanf(currentString, "%s", key);
                if (!readNum)
                    break;
            	currentString += strlen(key);
                if (currentString[0])
                    currentString++;
                [codeDict setObject: valueNumber
                        forKey: [[NSString stringWithCString: key] uppercaseString]];
                sprintf(key2, "\"%s\"", key);
                [codeDict setObject: valueNumber
                        forKey: [[NSString stringWithCString: key2] uppercaseString]];
            }
            continue;
        }
    }
    fclose(fp);
}


- (void) terminate: (NSNotification *) notification
{
NSMutableArray *fontNames;
NSMutableArray *fontSizes;
NSEnumerator *codeEnum;
NSNumber *codeNum;

    fontNames = [[NSMutableArray alloc] initWithCapacity: 1];
    fontSizes = [[NSMutableArray alloc] initWithCapacity: 1];
    codeEnum = [codeArray objectEnumerator];
    while (codeNum = [codeEnum nextObject])
    {
        [fontNames addObject:[[fontDict objectForKey: codeNum] fontName]];
        [fontSizes addObject:[NSNumber numberWithFloat:
                    [[fontDict objectForKey: codeNum] pointSize]]];
    }

#if 1
	[[NSUserDefaults standardUserDefaults]
           setObject: codeArray forKey: @"Code-Numbers"];
	[[NSUserDefaults standardUserDefaults]
           setObject: fontNames forKey: @"Font-Names"];
	[[NSUserDefaults standardUserDefaults]
           setObject: fontSizes forKey: @"Font-Sizes"];
#endif
}



- (void) setDefaultCode: (unsigned int)newDefaultCode
{
    defaultCode = newDefaultCode;
}

- (void) setMultipartFileCoding: (unsigned int)newMultipartFilecoding
{
    multipartFileCoding = newMultipartFilecoding;
}

- (void) setSendFileCoding: (unsigned int)newSendFileCoding
{
    sendFileCoding = newSendFileCoding;
}

- (NSDictionary *) charsetCodeDict
{
    return charsetCodeDict;
}

- (unsigned int) defaultCode
{
    return defaultCode;
}

#if 0
- (unsigned int) defaultFileCoding
{
    return [self fileCodeForCode: [self defaultCode]];
}


- (unsigned int) fileCodeForCode: (unsigned int) myCode
{
return 0;
}
#endif


- (unsigned int) multipartFileCoding
{
    return multipartFileCoding;
}

- (unsigned) sendFileCoding
{
    return sendFileCoding;
}


- (unsigned) codeFromCharset: (char *) charset isOMECharset: (BOOL) isOME
{
NSNumber *codeNum;
int i;
NSDictionary *dict;

    for(i = 0; charset[i]; i++)
    {
        if (charset[i] == ';' || charset[i] == '\n' || charset[i] == ' ')
        {
            charset[i] = 0;
            break;
        }
    }

	if (isOME)
		dict = omeCharsetCodeDict;
	else
		dict = charsetCodeDict;
	codeNum = [charsetCodeDict objectForKey:
					[[NSString stringWithCString: charset] uppercaseString]];
//NSLog(@"charset=%s", charset);
//NSLog(@"codeNum=%@", [codeNum description]);
	if (codeNum)
        return [codeNum unsignedIntValue];
    else if (isOME)
		return kCFStringEncodingInvalidId;
	else
        return [self defaultCode];
}


- (unsigned int) fileCodeFromCode: (unsigned int) code
{
NSNumber *codeNum;

    codeNum = [fileCodeDict objectForKey: [NSNumber numberWithUnsignedInt: code]];
    if (!codeNum)
        codeNum = [fileCodeDict objectForKey: [NSNumber numberWithUnsignedInt:
                            [self defaultCode]]];
    return [codeNum unsignedIntValue];
}


- (NSFont *) fontFromEncode: (unsigned int) encode
{
    return [fontDict objectForKey:[langNameDict objectForKey:
                            [NSNumber numberWithUnsignedInt: encode]]];
}


- (int)numberOfRowsInTableView:(NSTableView *)aTableView
{
    return [codeArray count];
}


- (id) tableView: (NSTableView *)tableView
		objectValueForTableColumn: (NSTableColumn *)tableColumn
		row: (int)row
{
	NSString *identifier = [tableColumn identifier];
	if ([identifier isEqualToString: @"code"])
        return [prefNameDict objectForKey:[codeArray objectAtIndex: row]];
    else if ([identifier isEqualToString: @"font"])
        return [(NSFont *)[fontDict objectForKey:[codeArray objectAtIndex: row]]
                        displayName];
    else if ([identifier isEqualToString: @"size"])
        return [NSNumber numberWithFloat: [(NSFont *)[fontDict objectForKey:
                        [codeArray objectAtIndex: row]] pointSize]];
    else
        return @"";
}




NSComparisonResult compareCode(NSNumber *code1, NSNumber *code2, void *dict)
{
    return [(NSString *)[(NSDictionary *)dict objectForKey: code1] compare:
                (NSString *)[(NSDictionary *)dict objectForKey: code2]]; 
}


- (IBAction) selectFont: (NSTableView *) table
{
NSFontManager *fontManager = [NSFontManager sharedFontManager];
NSFontPanel *fontPanel = [NSFontPanel sharedFontPanel];
NSNumber *codeNum;
NSFont *selectedFont;

    [fontManager setDelegate: self];
    [self setLastRow: [table clickedRow]];
    [fontPanel setDelegate: self];
    [fontManager orderFrontFontPanel: self]; //necessary to work
    codeNum = [codeArray objectAtIndex: [table clickedRow]];
    selectedFont = [fontManager convertFont:
                            [fontDict objectForKey: codeNum]];
    [fontManager setSelectedFont: selectedFont isMultiple: NO];
    [NSApp runModalForWindow: fontPanel];  //necessary to make front
}

- (void) changeFont: (NSFontManager *)sender
{
NSFontManager *fontManager = [NSFontManager sharedFontManager];
NSNumber *codeNum;
NSFont *selectedFont;
//NSFontPanel *fontPanel = [NSFontPanel sharedFontPanel];

    codeNum = [codeArray objectAtIndex: [self lastRow]];
    selectedFont = [fontManager convertFont:
                            [fontDict objectForKey: codeNum]];
    [fontDict setObject: selectedFont forKey: codeNum];
    [fontTable reloadData];
    //[fontPanel close];
}


- (void) setLastRow: (unsigned int) newLastRow
{
    lastRow = newLastRow;
}


- (unsigned int) lastRow
{
    return lastRow;
}


- (void) windowWillClose: (NSNotification *) notification
{
    [NSApp stopModal];
}
@end
