#import <Cocoa/Cocoa.h>

@class MailContents, KeyWindow, KeyMethod, BrowserTextView, MailTitles, MenuController, Chain;

@interface KeyController : NSObject
{
    IBOutlet MailContents	*mailContents;
    IBOutlet NSScrollView	*scrollView;
	NSMutableArray			*methodArray;
	IBOutlet NSWindow		*selectCommandWindow;
	IBOutlet KeyWindow		*keyWindow;
	KeyMethod 				*currentMethod;
	IBOutlet NSTextField	*keyWindowMessage;
	IBOutlet NSTableView	*selectTable;
	NSMutableDictionary		*keyMethodDict;
	NSMutableArray			*keyArray;
	IBOutlet NSTableView	*methodTable;
	IBOutlet NSTableView	*keyTable;
	IBOutlet NSWindow		*preferenceWindow;
	BrowserTextView			*browserTextView;
    IBOutlet MailTitles		*mailTitles;
    IBOutlet NSTableView	*mailTable;
    IBOutlet MenuController	*menuController;
}

- (void) awakeFromNib;
- (void) dealloc;
- (void) terminate: (NSNotification *) notification;

- (void) makeMethodArray;
- (void) addMethod: (SEL) newMethod name: (NSString *) newName
			serial: (int) newSerial;
- (NSDictionary *) keyMethodDict;
- (void) loadKeyMethodDict: (NSArray *) saveKeyArray;
- (void) keyMethodInit;
- (void) keyMethodAddKey: (NSString *)characters
			modifierFlags: (unsigned int)modifierFlags
			atIndex: (int) index;
- (void) setBrowserTextView: newBrowserTextView;
- (BOOL) handleKeyDown: (NSEvent *) event;
- (void) nextPage;
- (void) prevPage;
- (void) nextLine;
- (void) prevLine;
- (void) nextMail;
- (void) prevMail;
- (void) nextPageMail;
- (void) prevPageMail;
- (void) unreadMail;
- (IBAction)addKey: (NSMenuItem *) sender;
- (IBAction)enterKeyForCommand: (NSTableView *) sender;
- (IBAction)selectCommandCancel: (NSButton *) sender;
- (IBAction)keyWindowCancel: (NSButton *) sender;
- (int) numberOfRowsInTableView: (NSTableView *)tableView;
- (id) tableView: (NSTableView *)tableView
		objectValueForTableColumn: (NSTableColumn *)tableColumn
		row: (int)row;
- (void) keyDown: (NSEvent *) event;
- (IBAction) removeSelectionKey: (NSButton *) sender;
- (IBAction) removeAllKey: (NSButton *) sender;
@end
NSComparisonResult SortSerial(NSArray *methodKeyArray1,
					NSArray *methodKeyArray2, void *context);
