#import <Carbon/Carbon.h>

#import <stdlib.h>

#import "MailContents.h"
#import "Title.h"
#import "MailTitles.h"
#import "BrowserTextView.h"
#import "KeyController.h"
#import "Utils.h"
#import "Coding.h"

//OSErr SFPath2Spec(const char *fullPath, FSSpec *fssP);

static int unreadUtilRunning = 0;

@implementation MailContents

- (void) registerAndReplaceTextView
{
	[[NSNotificationCenter defaultCenter] addObserver: self
		selector: @selector(reloadContents:)
		name: NSTableViewSelectionDidChangeNotification object:nil];

	[scrollView setFrame: [[contentsWindow contentView] frame]];
	[self replaceTextView];
}


- (void) replaceTextView
{
	browserTextView = [[BrowserTextView alloc] initWithFrame:
							[textView frame]];
	[browserTextView setEditable: NO];
	[browserTextView setKeyController: keyController];
	[browserTextView setFont: [textView font]];
	[browserTextView setAutoresizingMask:
			NSViewHeightSizable | NSViewWidthSizable ];
	[browserTextView setHiddenText: hiddenText];
	[scrollView setDocumentView: browserTextView];
	[contentsWindow makeFirstResponder: browserTextView];
	[contentsWindow makeKeyAndOrderFront: self];
	[keyController setBrowserTextView: browserTextView];
}


- (void) dealloc
{
	[browserTextView release];
	[super dealloc];
}


- (BrowserTextView *) browserTextView
{
	return browserTextView;
}


- (NSString *) currentPathString
{
	return currentPathString;
}


- (void) setCurrentPathString: (NSString *) newPathString
{
	[currentPathString autorelease];
    currentPathString = [newPathString copy];
}


- (void) contentsAtPathString: (NSString *) pathString encode: (unsigned int)encode
{
	[browserTextView setString: [[[NSString alloc]
            initWithData: [NSData dataWithContentsOfFile: pathString]
            encoding: encode]
            autorelease]];
	[browserTextView scrollRangeToVisible: NSMakeRange(0, 0)]; /*scroll to the top*/
}


- (void) reloadContents: (NSNotification *) notification
{
/*tableViewSelectionDidChange*/
NSTableView *table = [notification object];
int index;
Title *title;
NSString *pathString;

	if (![table isEqualTo: titleTable])
		return;
	index = [table selectedRow];
	if (index >=0 )
	{
		title = (Title *)[[mailTitles mailTitles] objectAtIndex: index];
		pathString = [title pathString];
		if ([title unreadState])
		{
			[title makeRead];
			pathString = [title pathString];
			[table reloadData];
            
            if (!unreadUtilRunning)
            {
                unreadUtilRunning = 1;
                unreadUtilTimer = [NSTimer scheduledTimerWithTimeInterval: 1.0
						target: self selector: @selector(launchUnread:)
						userInfo: nil repeats: NO];
            }
		}
		[contentsWindow setTitle: [title subject]];
//NSLog(@"code=%u", [title code]);
//NSLog(@"correct code=%u", 5U);
//NSLog(@"file code=%u", [coding fileCodeFromCode: [title code]]);
//NSLog(@"correct code=%u", NSShiftJISStringEncoding);
        [self contentsAtPathString: pathString encode:
                    [coding fileCodeFromCode: [title code]]];
        [browserTextView setFont: [coding fontFromEncode: [title code]]];
		if (currentPathString)
			[currentPathString autorelease];
		currentPathString = [pathString copy];
	}
	else
	{
		[contentsWindow setTitle: Localize(@"No Mail")];
		[browserTextView setString: @""];
		if (currentPathString)
			[currentPathString autorelease];
		currentPathString = 0;
	}
}

- (void) launchUnread: (NSTimer *) timer
{
    unreadUtilRunning = 0;
    if (!system("ps xw | grep OME.UnreadUtility | grep -v grep > /dev/null"))
		return;
    if (!system("ps xw | grep \"sleep 5\" | grep -v grep > /dev/null"))
		return;
    system("(sleep 5; nice java -cp /Applications/OME_Applications/tools/OME_lib.jar:/System/Library/Java/ OME.UnreadUtility)&");
}

@end



