
#import "Title.h"
#import "MailTitles.h"
#import "MailDate.h"
#import "Utils.h"
#import "MailContents.h"
#import "Coding.h"

void RemoveLastNL(char *string);

@interface MailTitles (Private)
- (BOOL) isAttachedMail: (char *) filePath;
- (BOOL) CheckFileWithPath: (NSString *) pathString withExtension: extension
            returnName: (char *) filePath;
@end



@implementation MailTitles

void funcSetUnread(Title *title);
void funcDummySet(Title *title);
void funcSetReply(Title *title);
void funcSetHTML(Title *title);
void funcSetSend(Title *title);
void funcSetHTM(Title *title);
void funcSetUnreadNoMain(Title *title);
void funcSetNoMain(Title *title);

struct extentionDataType
{
    NSString *ext;
    void (*set)(Title *title);
} extData[] = {
        {@"ygm", &funcSetUnread},
        {@"mail", &funcDummySet},
        {@"rply", &funcSetReply},
        {@"rpry", &funcSetReply},
        {@"html", &funcSetHTML},
        {@"wmail", &funcSetSend},
        {@"htm", &funcSetHTM},
        {@"iygm", &funcSetUnreadNoMain},
        {@"imail", &funcSetNoMain},
        {0, 0},
};

void funcSetUnread(Title *title)
{
    [title setUnreadState: 1];
}

void funcDummySet(Title *title)
{
}

void funcSetReply(Title *title)
{
    [title setReplyState: 1];
}

void funcSetHTML(Title *title)
{
    [title setHtmlState: 1];
    [title setUnreadState: 1];
}


void funcSetSend(Title *title)
{
    [title setSendState: 1];
}


void funcSetHTM(Title *title)
{
    [title setHtmlState: 1];
}


void funcSetUnreadNoMain(Title *title)
{
    [title setUnreadState: 1];
    [title setNoMainState: 1];
}

void funcSetNoMain(Title *title)
{
    [title setNoMainState: 1];
}


- (id) init
{
	self = [super init];
	[self setMailTitles: [NSMutableArray array]];
	return self;
}


- (void) dealloc
{
	[mailTitles release];
	[super dealloc];
}


- (void)awakeFromNib
{
int index;
float width;
NSString *dateFormatString;
BOOL dateNaturalLanguage;
NSDateFormatter *dateFomat;

	[[NSNotificationCenter defaultCenter] addObserver: self
		selector: @selector(terminate:)
		name: NSApplicationWillTerminateNotification object:nil];

    if (index = [[NSUserDefaults standardUserDefaults]
                            integerForKey: @"Column Position State"])
        [table moveColumn: [table columnWithIdentifier: @"state"]
                toColumn: index - 1];
    if (index = [[NSUserDefaults standardUserDefaults]
                            integerForKey: @"Column Position From"])
        [table moveColumn: [table columnWithIdentifier: @"from"]
                toColumn: index - 1];
    if (index = [[NSUserDefaults standardUserDefaults]
                            integerForKey: @"Column Position Date"])
        [table moveColumn: [table columnWithIdentifier: @"date"]
                toColumn: index - 1];
    if (index = [[NSUserDefaults standardUserDefaults]
                            integerForKey: @"Column Position Subject"])
        [table moveColumn: [table columnWithIdentifier: @"subject"]
                toColumn: index - 1];

    if (width = [[NSUserDefaults standardUserDefaults]
                            floatForKey: @"Column Width State"])
        [[table tableColumnWithIdentifier: @"state"] setWidth: width];
    if (width = [[NSUserDefaults standardUserDefaults]
                            floatForKey: @"Column Width From"])
        [[table tableColumnWithIdentifier: @"from"] setWidth: width];
    if (width = [[NSUserDefaults standardUserDefaults]
                            floatForKey: @"Column Width Date"])
        [[table tableColumnWithIdentifier: @"date"] setWidth: width];
    if (width = [[NSUserDefaults standardUserDefaults]
                            floatForKey: @"Column Width Subject"])
        [[table tableColumnWithIdentifier: @"subject"] setWidth: width];

    if (dateFormatString = [[NSUserDefaults standardUserDefaults]
                            stringForKey: @"Date Format"])
    {
     	dateNaturalLanguage = [[NSUserDefaults standardUserDefaults]
                            boolForKey: @"Date Format Allow Natural Language"];
        dateFomat = [[[NSDateFormatter alloc]
            initWithDateFormat: dateFormatString
            allowNaturalLanguage: dateNaturalLanguage] autorelease];
        [[[table tableColumnWithIdentifier: @"date"]
            dataCell] setFormatter: dateFomat];
    }
}


- (void)terminate: (NSNotification *)notification
{
NSUserDefaults *defaults = [NSUserDefaults standardUserDefaults];
NSDateFormatter *dateFormat = [[[table tableColumnWithIdentifier: @"date"]
                dataCell] formatter];

	[defaults setInteger: [table columnWithIdentifier: @"state"]+1
            forKey: @"Column Position State"];
	[defaults setInteger: [table columnWithIdentifier: @"from"]+1
            forKey: @"Column Position From"];
	[defaults setInteger: [table columnWithIdentifier: @"date"]+1
            forKey: @"Column Position Date"];
	[defaults setInteger: [table columnWithIdentifier: @"subject"]+1
            forKey: @"Column Position Subject"];

	[defaults setFloat: [[table tableColumnWithIdentifier: @"state"] width]
            forKey: @"Column Width State"];
	[defaults setFloat: [[table tableColumnWithIdentifier: @"from"] width]
            forKey: @"Column Width From"];
	[defaults setFloat: [[table tableColumnWithIdentifier: @"date"] width]
            forKey: @"Column Width Date"];
	[defaults setFloat: [[table tableColumnWithIdentifier: @"subject"] width]
            forKey: @"Column Width Subject"];

	[defaults setObject: [dateFormat dateFormat]
            forKey: @"Date Format"];
	[defaults setBool: [dateFormat allowsNaturalLanguage]
            forKey: @"Date Format Allow Natural Language"];
}


- (NSMutableArray *) mailTitles
{
	return mailTitles;
}


- (void) setMailTitles: (NSMutableArray *) newMailTitles;
{
	[mailTitles autorelease];
	mailTitles = [newMailTitles retain];
	[table noteNumberOfRowsChanged];
}


- (bool) reverse
{
    return reverse;
}


- (void) setReverse: (bool) newReverse
{
	reverse = newReverse;
}


- (NSString *) identifier
{
    return lastIdentifier;
}


- (void) setIdentifier: (NSString *) newIdentifier
{
    [lastIdentifier autorelease];
    lastIdentifier = [newIdentifier copy];
}



- (int) numberOfRowsInTableView: (NSTableView *)tableView
{
	return [mailTitles count];
}


- (id) tableView: (NSTableView *)tableView
		objectValueForTableColumn: (NSTableColumn *)tableColumn
		row: (int)row
{
	NSString *identifier = [tableColumn identifier];
	Title *title = [mailTitles objectAtIndex: row];

	return [title valueForKey: identifier];
}


- (NSMutableArray *) loadTitleArray:(char *) dirPath
{
int i;
NSArray *contents;
NSMutableArray *array = [NSMutableArray array];
NSFileManager *fm = [NSFileManager defaultManager];
char filePath[1024];
int contentsCount;
const char *base;

	contents = [fm directoryContentsAtPath: [NSString
			stringWithUTF8String: dirPath]];
	
	contentsCount = [contents count];
	for (i = 0; i < contentsCount; i++)
	{
		base = [[contents objectAtIndex: i] fileSystemRepresentation];
		if (base[0] == '.')
			continue;
		sprintf(filePath, "%s/%s", dirPath, base);
        
        [self addTitleOf: filePath toArray: array];
	}

	return array;
}


- (void) addTitleOf:(const char *)inPath toArray:(NSMutableArray *)array
{
Title *title = 0;
FILE *curFile;
char oneLine[4096];
BOOL initTitle;
NSString *pathString;
NSString *extension;
BOOL archiveFlag = 0;
char fromString[1024];
char subjectString[1024];
int fromSet;
int subjectSet;
BOOL omeCharsetFound = NO;
BOOL contentTypeFound = NO;
unsigned code;
char base[1024];
NSFileManager *fm = [NSFileManager defaultManager];
char path[1024];

    strcpy(path, inPath);
    GetPathBase(path, base);

    omeCharsetFound = NO;
    contentTypeFound = NO;
    initTitle = 0;
    archiveFlag = 0;
    if (IsPathDirectory(path))
    {
        if (![self isAttachedMail: path])
            return;
        archiveFlag = 1;
        title = [[Title alloc] init];
        initTitle = 1;
        [title setArchiveState: 1];
    }
    
    pathString = Path2String(path);
    extension = [pathString pathExtension];
    if (![self isMailExtension: extension]
            && ![Path2String(base) hasPrefix: @"upload"]
            && !(archiveFlag && [extension isEqualTo: @""])
			&& ![Path2String(base) hasPrefix: @"error-mail-original"])
        return;

    if (!(curFile = fopen(path, "r")))
        return;
    
    if (!initTitle)
        title = [[[Title alloc] init] autorelease];
    if (archiveFlag)
        [title setArchiveState: 1];
    [title setPathString: pathString];
    [title setCode: [coding defaultCode]];
    
    if ([self setState: extension title: title])
        ;
    else if (archiveFlag && [extension isEqualTo: @""])
        [title setUnreadState: 1];
    else if ([extension isEqualTo: @"txt"]
            && [Path2String(base) hasPrefix: @"upload"])
        [title setSendState: 1];            
    else if ([Path2String(base) hasPrefix: @"error-mail-original"])
	{
		if ([extension isEqualTo: @"txt"])
			[title setUnreadState: 1];
        [title setErrorState: 1];
	}

    if ([title archiveState])
        [title setCode: [coding multipartFileCoding]];
    if ([title sendState])
        [title setCode: [coding sendFileCoding]];

    fromSet = 0;
    subjectSet = 0;
    while (fgets(oneLine, 4096, curFile))
    {
        if (oneLine[0] == '\n')
            break;
        RemoveLastNL(oneLine);
        if (HeadStrCL("From: ", oneLine) && ![title sendState])
        {
            strcpy(fromString, oneLine + strlen("From: "));
            fromSet = 1;
        }
        else if (HeadStrCL("To: ", oneLine) && [title sendState])
        {
            strcpy(fromString, oneLine + strlen("To: "));
            fromSet = 1;
            continue;
        }
        else if  (HeadStrCL("Subject: ", oneLine))
        {
            strcpy(subjectString, oneLine + strlen("Subject: "));
            subjectSet = 1;
            continue;
        }
        else if (HeadStrCL("Date: ", oneLine))
            [title setDate: CString2Date(oneLine + strlen("Date: "))];
#if 0
        else if (![self readContentType: "Content-Type: text/plain; charset="
                    ofLine: oneLine forTitle: title])
            if (![self readContentType: "Content-Type: text/plain;\r\tcharset="
                        ofLine: oneLine forTitle: title])
                if (![self readContentType: "Content-Type: text/plain;\tcharset="
                            ofLine: oneLine forTitle: title])
                    ;
                    if (![self readContentType: "Content-Type: text/plain;charset="
                                ofLine: oneLine forTitle: title])
                        ;
#endif
    }

    while (fgets(oneLine, 4096, curFile))
    {
//int i;
        if ((oneLine[0] != 'C') && (oneLine[0] != 'X'))
            continue;
//for (i = 0; oneLine[i]; i++)
//NSLog(@"%d %c %d", i, oneLine[i], oneLine[i]);

        if (!omeCharsetFound && HeadStrCL("X-OME-CharSet: ", oneLine))
        {
//NSLog(@"%s", oneLine + strlen("X-OME-CharSet: "));
            omeCharsetFound = YES;
            code = [coding codeFromCharset: oneLine + strlen("X-OME-CharSet: ")
                        isOMECharset: YES];
            if (code != kCFStringEncodingInvalidId)
            {
                [title setCode: code];
                break;
            }
            if (contentTypeFound)
                break;
        }

        if (!contentTypeFound 
            && ([self readContentType: "Content-Type: text/plain; charset="
                    ofLine: oneLine forTitle: title]
                || [self readContentType: "Content-Type: text/plain;\r\tcharset="
                        ofLine: oneLine forTitle: title]
                || [self readContentType: "Content-Type: text/plain;\tcharset="
                        ofLine: oneLine forTitle: title]
                || [self readContentType: "Content-Type: text/plain;charset="
                        ofLine: oneLine forTitle: title]
            ))
        {
            contentTypeFound = YES;
            if (omeCharsetFound)
                break;
        }
    }
    if (fromSet)
        [title setFrom: [self stringWithCString: fromString
                        encoding: [coding fileCodeFromCode: [title code]]]];            
    if (subjectSet)
        [title setSubject: [self stringWithCString: subjectString
                        encoding: [coding fileCodeFromCode: [title code]]]];            
    if ([title sendState])
        [title setDate: [[fm fileAttributesAtPath: pathString traverseLink: YES]
                objectForKey: NSFileModificationDate]];
    
    fclose(curFile);
    
    [array addObject: title];
}



- (int) readContentType: (char *)string ofLine: (char *)oneLine
            forTitle: (Title *)title
{
//NSLog(@"%s\n", oneLine);
    if (HeadStrCL(string, oneLine))
    {
        [title setCode: [coding codeFromCharset:
                oneLine + strlen(string) isOMECharset: NO]];
        return 1;
    }
    else
        return 0;
}



- (BOOL) isMailExtension:(NSString *) extension
{
BOOL result = NO;
int i;

    for (i = 0; extData[i].ext; i++)
    {
        if ([extension isEqualToString: extData[i].ext])
        {
            result = YES;
            break;
        }
    }
    return result;
}


- (BOOL) setState: (NSString *) extension title: (Title *) title
{
BOOL setDone = NO;
int i;

    for (i = 0; extData[i].ext; i++)
    {
        if ([extension isEqualToString: extData[i].ext])
        {
            setDone = YES;
            extData[i].set(title);
            break;
        }
    }
    return setDone;
}

- (void) loadTitleTable: (char *) dirPath refresh: (BOOL) refresh
{
    refresh = (refresh || (![mailTitles count]));
	[self setMailTitles: [self loadTitleArray: dirPath]];
    [self sortTitle];
    if (refresh)
    {
        [table deselectRow: 0]; /*refresh mailContents*/
        if ([mailTitles count])
        {
            [table selectRow: 0 byExtendingSelection: NO];
        }
        [self readUnreadMail: self];
    }
    else
    {
        [table selectRow: [self findIndex] byExtendingSelection: NO];
    }
}


- (int) findIndex
{
int index;
NSString *curPath = [mailContents currentPathString];
int count = [mailTitles count];

    for (index = count-1; index>0; index--)
        if ([curPath isEqualToString: [(Title *)[mailTitles objectAtIndex: index] pathString]])
            break;;
    
    return index;
}


- (BOOL) isAttachedMail: (char *) filePath
{
NSString *pathString = Path2String(filePath);
NSString *extension = [pathString pathExtension];
NSString *base;
NSString *body;
int i;

//printf("extension = %s\n", [extension cString]);
	if (![self isMailExtension: extension]
        && ![extension isEqualToString: @"mpart"]
         )
		return 0;
 
	base = [pathString lastPathComponent];
	body = [base stringByDeletingPathExtension];
	pathString = [pathString stringByAppendingPathComponent: body];
    
    for (i = 0; extData[i].ext; i++)
    {
        if ([self CheckFileWithPath: pathString withExtension: extData[i].ext
                returnName: filePath])
            return 1;
    }
	if ([self CheckFileWithPath: pathString withExtension: @"ygm.html"
            returnName: filePath])
		return 1; /*HTML mail has double extension*/
	if ([self CheckFileWithPath: pathString withExtension: 0
            returnName: filePath]) /*deal with bug of MessageMaker that does not add extension*/
		return 1;
	
	
	/* mails that lack main text*/
	[self makeDummyMainAtPath: pathString  returnName: filePath];
	
	return 1;
	
	//return 0;
}


- (BOOL) CheckFileWithPath: (NSString *) pathString withExtension: extension
            returnName: (char *) filePath
{
NSString *pathCandidate;
    if (extension)
        pathCandidate = [pathString stringByAppendingPathExtension: extension];
    else
        pathCandidate = pathString;
	if ([[NSFileManager defaultManager] fileExistsAtPath: pathCandidate])
	{
		strcpy(filePath, [pathCandidate fileSystemRepresentation]);
		return YES;
	}
    return NO;
}


- (void) removeAtIndex: (int) index
{
	[mailTitles removeObjectAtIndex: index];
	[table deselectRow: index];
	[table reloadData];
	if (index >= [mailTitles count])
		index = [mailTitles count]-1;
	if (index >= 0)
		[table selectRow: index byExtendingSelection: NO];
}


- (void) tableView: (NSTableView *) tableView
		didClickTableColumn: (NSTableColumn *) tableColumn /*delegate*/
{
    if ([[tableColumn identifier] isEqualToString: lastIdentifier])
        reverse = !reverse;
    else
    {
        lastIdentifier = [tableColumn identifier];
    }

    if (reverse)
    {
        [mailTitles sortUsingFunction: reverseCompareTitle
                context: lastIdentifier];
    }
    else
    {
        [mailTitles sortUsingFunction: compareTitle
                context: lastIdentifier];
    }
	[table reloadData];
	[table deselectRow: 0]; /*refresh mailContents*/
	if ([mailTitles count])
	{
		[table selectRow: 0 byExtendingSelection: NO];
	}
}


- (void) readNextMail
{
int index = [table selectedRow];

	[table deselectRow: index];
	index++;
    [self showInTitleIndex: index];
}

- (void) showInTitleIndex: (int) index
{
	if (index >= [mailTitles count])
		index = [mailTitles count]-1;
	if (index >= 0)
	{
		[table selectRow: index byExtendingSelection: NO];
		[table scrollRowToVisible: [mailTitles count]-1]; /*put the selection at top*/
		[table scrollRowToVisible: index];
	}
}

- (NSString *) stringWithShiftJISString: (char *) shiftJISString
{
    return [[NSString alloc]
                    initWithData: [NSData dataWithBytes: shiftJISString
                            length: strlen(shiftJISString)]
                    encoding: NSShiftJISStringEncoding];
}

- (NSString *) stringWithCString: (char *) string encoding: (unsigned int)encoding
{
    return [[NSString alloc] initWithData: [NSData dataWithBytes: string
                    length: strlen(string)] encoding: encoding];
}


- (IBAction) readUnreadMail: (id)sender
{
int currentIndex = [table selectedRow];
int index;
Title *title;

    if (![mailTitles count])
        return;

	[table deselectRow: currentIndex];
	
    for (index = currentIndex; index < [mailTitles count]; index++)
    {
		title = [mailTitles objectAtIndex: index];
		if ([title unreadState])
            break;
    }
	if (index >= [mailTitles count])
        index = currentIndex;
	
    [table selectRow: index byExtendingSelection: NO];
    [table scrollRowToVisible: [mailTitles count]-1];
    [table scrollRowToVisible: index];
}


- (void) sortTitle
{
    if (reverse)
        [mailTitles sortUsingFunction: reverseCompareTitle
                    context: lastIdentifier];
    else
        [mailTitles sortUsingFunction: compareTitle
                    context: lastIdentifier];
}


- (IBAction) unreadMailTitles:(NSMenu *)sender
{

    [mailTitleWindow setTitle: Localize(@"Unread Mails")];

    [self setMailTitles: [self loadUnreadTitleArray]];
    [self sortTitle];
}


- (NSMutableArray *) loadUnreadTitleArray
{
int i;
NSArray *contents;
NSMutableArray *array = [NSMutableArray array];
NSFileManager *fm = [NSFileManager defaultManager];
char filePath[1024], realPath[1024];
int contentsCount;
const char *base;
NSString *aliasPath;

    aliasPath = [omeRootPathString stringByAppendingPathComponent:
                    @"temp/unreadAliases"];
	contents = [fm directoryContentsAtPath: aliasPath];
	if (!contents)
        return 0;
	contentsCount = [contents count];
	for (i = 0; i < contentsCount; i++)
	{
		base = [[contents objectAtIndex: i] fileSystemRepresentation];
		if (base[0] == '.')
			continue;
		sprintf(filePath, "%s/%s", [aliasPath fileSystemRepresentation], base);
        
        SFResolveAliasPath(filePath, realPath, 1024);
        [self addTitleOf: realPath toArray: array];
	}
	
	return array;
}


- (void) makeDummyMainAtPath: (NSString *)pathString  returnName: (char *)filePath
{
NSArray *mailFileName = [[pathString lastPathComponent] componentsSeparatedByString: @"|"];
NSString *contents;
BOOL success;
NSFileManager *fm = [NSFileManager defaultManager];
NSDate *date;
NSString *parentDirectory = [pathString stringByDeletingLastPathComponent];
NSString *newPath;

	date = [[fm fileAttributesAtPath: parentDirectory traverseLink: YES]
                objectForKey: NSFileCreationDate];
	contents = [NSString stringWithFormat: 
					@"From: %@\nSubject: %@\nDate: %@\n\n No main text in this mail.",
					[mailFileName objectAtIndex: 0], [mailFileName objectAtIndex: 1],
					[date descriptionWithCalendarFormat: @"%a, %d %b %Y %H:%M:%S %z(%Z)" 
						timeZone: [NSTimeZone localTimeZone] locale: nil]];
	newPath = [pathString stringByAppendingPathExtension: @"iygm"];
	success = [fm createFileAtPath: newPath 
				contents: [contents dataUsingEncoding: NSShiftJISStringEncoding]
				attributes: nil];

	[fm changeFileAttributes: [NSDictionary dictionaryWithObject: date forKey: NSFileModificationDate]
		atPath: newPath];
	[fm changeFileAttributes: [NSDictionary dictionaryWithObject: date forKey: NSFileModificationDate]
		atPath: parentDirectory];
	
	strcpy(filePath, [newPath fileSystemRepresentation]);
}



@end

void RemoveLastNL(char *string)
{
	if (string[strlen(string)-1] == '\n')
		string[strlen(string)-1] = 0;
}