#import <Cocoa/Cocoa.h>

@class MailContents, MailTitles, AppController;

@interface MenuController : NSObject
{
    IBOutlet NSBrowser		*fsBrowser;
	IBOutlet NSMenu			*moveMenu;
	IBOutlet NSTableView	*table;
    IBOutlet MailContents	*mailContents;
	IBOutlet MailTitles		*mailTitles;
	IBOutlet NSPanel		*removeWindow;
	IBOutlet AppController	*appController;
	IBOutlet NSWindow		*folderWindow;
	IBOutlet NSWindow		*titleWindow;
	IBOutlet NSWindow		*contentsWindow;

	NSMutableArray			*moveArray;
    
    IBOutlet NSMenuItem		*sortFolderByName;
    IBOutlet NSMenuItem		*sortFolderByModDate;

	IBOutlet NSTableView	*moveTable;
    IBOutlet NSWindow		*confirmWindow;
    
    IBOutlet NSTextView		*hiddenText;

	NSTimer *unreadUtilTimer;
}

- (IBAction) printSelection: (NSMenuItem *)sender;

- (IBAction) readNextMail: (NSMenuItem *)sender;
- (IBAction) download: (id) sender; /*used by 2 classes*/
- (IBAction) reply: (NSMenuItem *)sender;
- (IBAction) newMail: (NSMenuItem *)sender;
- (IBAction) openByMailReader: (NSMenuItem *)sender;
- (IBAction) deleteMail: (NSMenuItem *)sender;
- (IBAction) deleteMailYes:(NSButton *)sender;
- (IBAction) deleteMailNo:(NSButton *)sender;

- (IBAction) addCurrentFolder: (NSMenuItem *)sender;
- (void)addFolder: (NSString *) folderPathString;
- (IBAction) remove: (NSMenuItem *) sender;
- (IBAction) removeCancel: (NSButton *) sender;
- (IBAction) removeItem: (NSTableView *) sender;
- (IBAction) removeAll: (NSTableView *) sender;

- (IBAction) refreshList: (NSMenuItem *) sender;
- (IBAction) browseInBox: (NSMenuItem *) sender;

- (int) numberOfRowsInTableView: (NSTableView *)tableView;
- (id) tableView: (NSTableView *)tableView
		objectValueForTableColumn: (NSTableColumn *)tableColumn
		row: (int)row;

- (void) saveMoveArray: (NSNotification *) notification;

- (void) dealloc;
- (void) awakeFromNib;
- (void) addFolderPathString: (NSString *) folderPathString
			atIndex: (int) index;
- (void) moveMailTo: (NSMenuItem *) sender;
- (void) moveMailToDirectory: (NSString *) newDirPathString;
- (void) checkDownloading: (NSTimer *) timer;

- (void) allFront: (NSNotification *) notification;

- (IBAction) sortFolderByMenu: (NSMenuItem *) sender;
- (void) sortFolderByTag: (NSString *) tag;

/*- (BOOL) applicationOpenUntitledFile: (NSApplication *) theApp;*/

- (IBAction) launchURL: (NSMenuItem *) sender;
- (IBAction) addressBook: (NSMenuItem *) sender;
- (IBAction) showMail: (NSMenuItem *) sender;
- (IBAction) search: (NSMenuItem *) sender;
- (IBAction) OMEMove: (NSMenuItem *) sender;

- (IBAction) addFolderAndMove: (NSMenuItem *) sender;

- (IBAction) makeRead: (NSMenuItem *) sender;
@end
