#import "MethodKey.h"

@implementation MethodKey

#if 0 /*does not work*/
- (BOOL) isEqual: (id) methodKey2
{
printf("characters1 = %s\n", [[self characters] cString]);fflush(stdout);
printf("characters2 = %s\n", [[methodKey2 characters] cString]);fflush(stdout);
printf("modifierFlags1 = %u\n", [self modifierFlags]);fflush(stdout);
printf("modifierFlags2 = %u\n", [methodKey2 modifierFlags]);fflush(stdout);

	return ([[self characters] isEqualToString: [methodKey2 characters]]
				&& ([self modifierFlags] == [methodKey2 modifierFlags]));
}
#endif

- (MethodKey *) initWithCharacters: (NSString *) newCharacters
			modifierFlags: (unsigned int) newModifierFlags
{
	self = [super init];
	characters = [newCharacters copy];
	modifierFlags = newModifierFlags;
	return self;
}


- (MethodKey *) initWithEvent: (NSEvent *) event
{
	self = [self initWithCharacters:
			[event charactersIgnoringModifiers]
			modifierFlags: [event modifierFlags]];
	return self;
}

- (MethodKey *) initWithArray: (NSArray *) array
{
	self = [self initWithCharacters:
			[array objectAtIndex: 0]
			modifierFlags: [[array objectAtIndex: 1] unsignedIntValue]];
	return self;
}


- (void) dealloc
{
	[characters release];
	[super dealloc];
}


- (MethodKey *) copyWithZone: (NSZone *) zone
{
MethodKey *copyMK = [[MethodKey allocWithZone: zone]
						initWithCharacters: [self characters]
						modifierFlags: [self modifierFlags]];
	return copyMK;
}


- (NSString *) characters
{
	return characters;
}


- (unsigned int) modifierFlags
{
	return modifierFlags;
}


- (void) setCharacters: (NSString *) newCharacters
{
	[characters autorelease];
	characters = [newCharacters copy];
}


- (void) setModifierFlags: (unsigned int) newModifierFlags
{
	modifierFlags = newModifierFlags;
}


- (NSArray *) makeKey /*Dictionary does not work for custom key ???*/
{
	return [NSArray arrayWithObjects: characters,
					[NSNumber numberWithUnsignedInt: modifierFlags],
					nil];
}


- (NSString *) shiftString
{
	if ([self modifierFlags] & NSShiftKeyMask)
		return @"Shift+";
	else
		return @"";
}


- (NSString *) capsLockString
{
	if ([self modifierFlags] & NSAlphaShiftKeyMask)
		return @"Caps+";
	else
		return @"";
}


- (NSString *) optionString
{
	if ([self modifierFlags] & NSAlternateKeyMask)
		return @"Opt+";
	else
		return @"";
}


- (NSString *) controlString
{
	if ([self modifierFlags] & NSControlKeyMask)
		return @"Ctrl+";
	else
		return @"";
}


- (NSString *) functionString
{
	if ([self modifierFlags] & NSFunctionKeyMask)
		return @"F+";
	else
		return @"";
}


- (NSString *) keyString
{
	if ([[self characters] isEqualToString: @" "])
		return @"Space";
	else if ([[self characters] isEqualToString: @"\r"])
		return @"Return";
	else
	{
		switch([[self characters] characterAtIndex: 0])
		{
		case NSUpArrowFunctionKey: return @"UpArrow"; break;
		case NSDownArrowFunctionKey: return @"DownArrow"; break;
		case NSLeftArrowFunctionKey: return @"LeftArrow"; break;
		case NSRightArrowFunctionKey: return @"RightArrow"; break;
		case NSF1FunctionKey: return @"F1"; break;
		case NSF2FunctionKey: return @"F2"; break;
		case NSF3FunctionKey: return @"F3"; break;
		case NSF4FunctionKey: return @"F4"; break;
		case NSF5FunctionKey: return @"F5"; break;
		case NSF6FunctionKey: return @"F6"; break;
		case NSF7FunctionKey: return @"F7"; break;
		case NSF8FunctionKey: return @"F8"; break;
		case NSF9FunctionKey: return @"F9"; break;
		case NSF10FunctionKey: return @"F10"; break;
		case NSF11FunctionKey: return @"F11"; break;
		case NSF12FunctionKey: return @"F12"; break;
		default:
			return [self characters];
			break;
		}
	}
}

@end
