#import "Preferences.h"

#import "MenuController.h"

@implementation Preferences


- (IBAction) preference: (NSMenuItem *) sender
{
	[keyTable noteNumberOfRowsChanged];
	[downloadAtStartUpSwitch setState: downloadAtStartUp];
	[repeatDownloadSwitch setState: repeatDownload];
	[downloadIntervalField setIntValue: downloadInterval];
	[NSApp runModalForWindow: preferenceWindow];
}


- (IBAction) preferenceDone: (NSButton *) sender
{
	[NSApp stopModal];
    [menuController allFront: nil];
	[preferenceWindow close];
	[self intervalChanged: downloadIntervalField];
}

- (void) loadPrefAndStartUpDownload
{
NSUserDefaults *defaults;

	defaults = [NSUserDefaults standardUserDefaults];
	downloadAtStartUp = [defaults boolForKey: @"Download At Start Up"];
	repeatDownload = [defaults boolForKey: @"Repeat Download"];
	if (!(downloadInterval = [defaults integerForKey:
			@"Download Interval in Minutes"]))
		downloadInterval = 10;
	
	if (downloadAtStartUp)
		[menuController download: self];
	
	if (repeatDownload)
		[self startRepeatDownload];

	[defaults setInteger: 1 forKey: @"Major Version"];
	[defaults setInteger: 1 forKey: @"Minor Version"];
	[defaults setInteger: 0 forKey: @"Mentenance Version"];
}


- (void) repeatDownload: (NSTimer *) timer
{
	[menuController download: self];
}


- (IBAction) switchDownloadAtStartUp: (NSButton *) sender
{
	downloadAtStartUp = [sender state];
	[[NSUserDefaults standardUserDefaults] setBool: downloadAtStartUp
				forKey: @"Download At Start Up"];
}


- (IBAction) switchRepeatDownload: (NSButton *) sender
{
	repeatDownload = [sender state];
	[[NSUserDefaults standardUserDefaults] setBool: repeatDownload
				forKey: @"Repeat Download"];
	if (repeatDownload)
		[self startRepeatDownload];
	else
		[downloadTimer invalidate];
}

- (void) startRepeatDownload
{
NSTimeInterval nsInterval;

	nsInterval = downloadInterval*60;
	downloadTimer = [NSTimer scheduledTimerWithTimeInterval: nsInterval
						target: self selector: @selector(repeatDownload:)
						userInfo: nil repeats: YES];
}


- (IBAction) intervalChanged: (NSTextField *) sender
{
int newInterval = [sender intValue];

	if (downloadInterval == newInterval)
		return;
	downloadInterval = newInterval;
	if (downloadInterval <= 0)
		downloadInterval = 1;
	[[NSUserDefaults standardUserDefaults] setInteger: downloadInterval
			forKey: @"Download Interval in Minutes"];
	if (repeatDownload)
	{
		[downloadTimer invalidate];
		[self startRepeatDownload];
	}
}


@end
