//
//  Title.m
//  table
//
//  Created by takahasi on Fri Sep 14 2001.
//  Copyright (c) 2001 __CompanyName__. All rights reserved.
//

#import "Title.h"
#import "Utils.h"

#ifndef MaxStates
#define MaxStates 20
#endif

enum stateCoef
{
	archiveCoef = 1,
	unreadCoef,
    replyCoef,
    htmlCoef,
    sendCoef,
	noMainCoef,
	errorCoef
};




@implementation Title

static NSString *(stateChars[]) = {@"", @"A", @"U", @"R", @"H", @"S", @"X", @"E"};

- (id) init
{
	self = [super init];
	[self setFrom: Localize(@"anonymous")];
	[self setDate: [NSCalendarDate distantPast]];
	[self setSubject: Localize(@"No Subject")];
	[self setPathString: @""];
	[self setArchiveState: 0];
	[self setUnreadState: 0];
	[self setReplyState: 0];
	[self setHtmlState: 0];
	[self setSendState: 0];
	[self setNoMainState: 0];
	[self setErrorState: 0];
	return self;
}


- (void) dealloc
{
	[from release];
	[date release];
	[subject release];
	[pathString release];
	[super dealloc];
}


- (NSString *) from
{
	return from;
}


- (NSCalendarDate *) date
{
	return date;
}


- (NSString *) subject
{
	return subject;
}


- (NSString *) state
{
	return [NSString stringWithFormat: @"%@%@%@%@%@%@%@%@",
		stateChars[archiveCoef*archiveState],
		stateChars[unreadCoef*unreadState],
		stateChars[replyCoef*replyState],
		stateChars[htmlCoef*htmlState],
		stateChars[sendCoef*sendState],
		stateChars[noMainCoef*noMainState],
		stateChars[errorCoef*errorState],
		@""];
}


- (BOOL) archiveState
{
	return archiveState;
}


- (BOOL) unreadState
{
	return unreadState;
}


- (BOOL) replyState
{
	return replyState;
}


- (BOOL) htmlState
{
	return htmlState;
}


- (BOOL) sendState
{
	return sendState;
}


- (BOOL) noMainState
{
	return noMainState;
}


- (BOOL) errorState
{
	return errorState;
}


- (NSString *) pathString
{
	return pathString;
}

- (unsigned int) code
{
    return code;
}

- (void) setFrom: (NSString *)value
{
	[from autorelease];
	from = [value copy];
}


- (void) setDate: (NSCalendarDate *)value
{
	[date autorelease];
	date = [value copy];
}


- (void) setPathString: (NSString *)value
{
	[pathString autorelease];
	pathString = [value copy];
}


- (void) setSubject: (NSString *)value
{
	[subject autorelease];
	subject = [value copy];
}


- (void) setArchiveState: (BOOL) newArchiveState
{
	archiveState = newArchiveState;
}


- (void) setUnreadState: (BOOL) newUnreadState
{
	unreadState = newUnreadState;
}


- (void) setReplyState: (BOOL) newReplyState
{
	replyState = newReplyState;
}



- (void) setHtmlState: (BOOL) newHtmlState
{
	htmlState = newHtmlState;
}


- (void) setSendState: (BOOL) newSendState
{
	sendState = newSendState;
}


- (void) setNoMainState: (BOOL) newNoMainState
{
	noMainState = newNoMainState;
}


- (void) setErrorState: (BOOL) newErrorState
{
	errorState = newErrorState;
}


- (void) setCode: (unsigned int)newCode
{
    code = newCode;
}


- (void) makeRead
{
NSString *newPathString;

	if ([self unreadState])
	{
		[self setUnreadState: 0];
		if ([self htmlState])
			newPathString = [[pathString stringByDeletingPathExtension]
					stringByAppendingPathExtension: @"htm"];
		else if ([self noMainState])
			newPathString = [[pathString stringByDeletingPathExtension]
					stringByAppendingPathExtension: @"imail"];
		else if ([self errorState])
			newPathString = [[pathString stringByDeletingPathExtension]
					stringByAppendingPathExtension: @"rtxt"];
		else
			newPathString = [[pathString stringByDeletingPathExtension]
					stringByAppendingPathExtension: @"mail"];
		[[NSFileManager defaultManager] movePath: pathString
				toPath: newPathString handler: nil];
		//pathString = [NSString stringWithString: newPathString];
		[pathString autorelease];
		pathString = [newPathString copy];
		//[self setPathString: pathString];
		if (![self htmlState])
			SFCoSetTypeCreator([pathString fileSystemRepresentation],
								'TEXT', 'ome1');
	}
}


@end

NSComparisonResult compareTitle(Title *title1, Title *title2, void *context)
{
NSString *identifier = (NSString *)context;

#if 1
		return [[title1 valueForKey: identifier] compare:
					[title2 valueForKey: identifier]];
#else
	if ([identifier isEqualToString: @"date"])
		return [(NSDate *)[title1 valueForKey: identifier] compare:
					(NSDate *)[title2 valueForKey: identifier]];
	else
		return [(NSString *)[title1 valueForKey: identifier] compare:
					(NSString *)[title2 valueForKey: identifier]];
#endif
}

NSComparisonResult reverseCompareTitle(Title *title1, Title *title2, void *context)
{
    return - compareTitle(title1, title2, context);
}

